<?php
namespace Financeiro\Repositories;

class Adiantapagar extends \Doctrine\ORM\EntityRepository
{

    public function verificaAdiantamento($cdempresa, $cdforneced){
        $sql = <<<SQL
                  SELECT
                    A.VRTOTADIA,
                    A.VRDISPONIVEL,
                    A.NRLANCTONF,
                    A.NRSEQVENPAG,
                    A.NRPARCELAPAG,
                    A.CDFILIAL,
                    A.VRORIGINAL,
                    A.IDMARCADO ,
                    A.VRDESCONTO,
                    A.IDTPIJURFORN,
                    A.NMRAZSOCFORN,
                    A.NRINSJURFORN,
                    A.DTATUAVENPAG
                    FROM
                    (SELECT
                       NVL(SUM(AR.VRADIANTAPAG), 0) VRTOTADIA,
                       CP.VRATUAPAG - NVL(SUM(AR.VRADIANTAPAG), 0) VRDISPONIVEL,
                       CP.NRLANCTONF,
                       CP.NRSEQVENPAG,
                       CP.NRPARCELAPAG,
                       CP.CDFILIAL,
                       CP.VRATUAPAG    VRORIGINAL,
                       'N'   AS       IDMARCADO ,
                        0             VRDESCONTO,
                       FR.IDTPIJURFORN,
                       FR.NMRAZSOCFORN,
                       FR.NRINSJURFORN,
                       CP.DTATUAVENPAG
                    FROM
                       NOTAFISCAL    NF,
                       CONTAPAGAR    CP,
                       ADIANTAPAGAR  AR,
                       FORNECEDOR    FR,
                       TIPOCTPAGAR   TP
                    WHERE
                       NF.CDFORNECED      = FR.CDFORNECED    AND
                       NF.CDEMPRESA       = :P_CDEMPRESA    AND
                       FR.CDFORNECED      = :P_CDFORNECED    AND
                       CP.CDFILIAL        = NF.CDFILIAL      AND
                       CP.NRLANCTONF      = NF.NRLANCTONF    AND
                       AR.CDFILIAL    (+) = CP.CDFILIAL      AND
                       AR.NRLANCTONF  (+) = CP.NRLANCTONF    AND
                       AR.NRSEQVENPAG (+) = CP.NRSEQVENPAG   AND
                       AR.NRPARCELAPAG(+) = CP.NRPARCELAPAG  AND
                       CP.CDTPCTPAGAR     = TP.CDTPCTPAGAR   AND
                       TP.IDTPCTPAGAR     = '2'              AND
                       NF.IDNFDISPFIN     = 'S'              AND
                       CP.IDSTATPAG       = 'B'
                    GROUP BY
                       CP.NRLANCTONF,
                       CP.NRSEQVENPAG,
                       CP.NRPARCELAPAG,
                       CP.CDFILIAL,
                       CP.VRATUAPAG,
                       'N',
                       0 ,
                       FR.IDTPIJURFORN,
                       FR.NMRAZSOCFORN,
                       FR.NRINSJURFORN,
                       CP.DTATUAVENPAG
                    HAVING
                       NVL(SUM(AR.VRADIANTAPAG),0) <> CP.VRATUAPAG) A
SQL;
        $params = array(
            "P_CDEMPRESA" => $cdempresa,
            "P_CDFORNECED" => $cdforneced
        );

        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    }

    public function verificaDevolucao($cdempresa, $cdforneced){
        $sql = <<<SQL
                  SELECT DISTINCT
                       IDMARCADO,
                       DOCUMENTO,
                       FILIDEVO,
                       NRNFDEVO,
                       DTEMISSAO,
                       VRDISPONIVEL,
                       VRDESCONTO,
                       VRNFDEVOL,
                       NRINSJURFORN,
                       IDTPIJURFORN,
                       NMRAZSOCFORN,
                       (SELECT MAX(NRNOTAFISC || '/' || CDSERIEENTR)
                          FROM ITEMNOTAFISC ITF, NOTAFISCAL NFC
                         WHERE ITF.CDFILIAL = FILIDEVO
                           AND ITF.NRLANCTONF = NRNFDEVO
                           AND NFC.CDFILIAL = ITF.CDFILIALIT
                           AND NFC.NRLANCTONF = ITF.NRLANCTONFIT) AS DOCUMENTOORI

                    FROM
                       (SELECT
                           'N'   AS        IDMARCADO  ,
                           NFD.NRNOTAFISC || '/' || NFD.CDSERIE  DOCUMENTO,
                           NFD.CDFILIAL      FILIDEVO,
                           NFD.NRLANCTONF    NRNFDEVO,
                           NFC.CDFILIAL      FILICOMPRA,
                           NFC.NRLANCTONF    NRNFCOMPRA,
                           NFD.DTEMISSAO,
                           NFD.VRNOTAFISC - NVL(NFD.VRDEVOLNFUTL, 0) VRDISPONIVEL,
                           0               VRDESCONTO,
                           NFD.VRNOTAFISC  VRNFDEVOL,
                           FO.NRINSJURFORN,
                           FO.IDTPIJURFORN,
                           FO.NMRAZSOCFORN,
                           NFC.NRNOTAFISC || '/' || NFC.CDSERIE  DOCUMENTOORI
                      FROM NOTAFISCAL NFC, CONTAPAGAR CP, ITEMNOTAFISC ITF, NOTAFISCAL NFD,

                          (SELECT IDENTRSAIDOP, CDTIPOOPER
                             FROM TIPOOPERAC WHERE IDOPERDEVONF = 'S') TP,

                          (SELECT CDFORNECED, NRINSJURFORN, IDTPIJURFORN, NMRAZSOCFORN
                             FROM FORNECEDOR WHERE CDFORNECED = :P_CDFORNECED) FO

                     WHERE NFC.CDEMPRESA = :P_CDEMPRESA
                       AND NFC.IDENTRSAIDOP = 'E'
                       AND NFC.CDFILIAL = CP.CDFILIAL
                       AND NFC.NRLANCTONF = CP.NRLANCTONF
                       AND NFC.CDFORNECED = FO.CDFORNECED
                       AND NFC.CDFILIAL = ITF.CDFILIALIT
                       AND NFC.NRLANCTONF = ITF.NRLANCTONFIT
                       AND NFD.CDFILIAL = ITF.CDFILIAL
                       AND NFD.NRLANCTONF = ITF.NRLANCTONF
                       AND NFD.IDSTATUS IN ('A', 'E')
                       AND NFD.IDENTRSAIDOP = TP.IDENTRSAIDOP
                       AND NFD.IDNFDISPFIN = 'S'
                       AND NFD.CDTIPOOPER = TP.CDTIPOOPER
                       AND NFD.IDENTRSAIDOP = 'S'
                       AND NOT EXISTS (SELECT 1
                                         FROM CONTARECEBER CR
                                        WHERE CR.CDFILIAL = NFD.CDFILIAL
                                          AND CR.NRLANCTONF = NFD.NRLANCTONF)
                       AND EXISTS (SELECT 1
                                     FROM CONTAPAGAR CP
                                    WHERE CP.CDFILIAL = NFC.CDFILIAL
                                      AND CP.NRLANCTONF = NFC.NRLANCTONF))

                    WHERE VRDISPONIVEL > 0
                    ORDER BY DOCUMENTO, DTEMISSAO
SQL;
        $params = array(
            "P_CDEMPRESA" => $cdempresa,
            "P_CDFORNECED" => $cdforneced
        );

        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    }

}