<?php

namespace Folha\Logic\Ocorrencia;
/**
 * Description of Ocorrencia
 *
 * @author carinaoliveira
 */
use SistemaQualidade\Entities\Acao;
class Ocorrencia {
    
    public static function deletaOcorrencia($nrorgOco,$nrOcorrencia) {
        
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $message = tk_get_message_by_name('msg_ExclusaoRealizada');
        
        try {
            $ocorrencia = \Folha\Entities\SstOcorrencia::findOneByNrorgAndNrocorrencia($nrorgOco,$nrOcorrencia);
            $vitimas = \Folha\Entities\SstVitima::findByNrorgAndNrocorrencia($nrorgOco,$nrOcorrencia);
            
            foreach($vitimas as $vitima) {
                
                $partesAtingidas = \Folha\Entities\Sstvitimaparteatingida::findByNrorgAndNrocorrenciaAndNrvitima($nrorgOco,$nrOcorrencia, $vitima->getNrvitima());
                foreach($partesAtingidas as $parte) {
                    
                    $parte->delete();  
                                       
                }
                $vitima->delete(); //deleta vitima
            }
            $ocorrencia->delete();
            
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->flush();
            $db->commit();
            tk_reload_data_with_filter('tab_sst00020_000_000');
            tk_message($message, 'success');
        } catch (\Exception $e) {
            $message = tk_get_message_by_name('msg_ExclusaoImpossibilitada');
            tk_message($message, 'warning');
            $db->rollback();
        }         
                   
    }
    
    public static function deletaVitima($nrorgOco,$nrOcorrencia,$nrVitima) {
        
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $message = tk_get_message_by_name('msg_ExclusaoRealizada');
        
        try {
            $vitima = \Folha\Entities\SstVitima::findOneByNrorgAndNrocorrenciaAndNrvitima($nrorgOco,$nrOcorrencia,$nrVitima);
            $partesAtingidas = \Folha\Entities\Sstvitimaparteatingida::findByNrorgAndNrocorrenciaAndNrvitima($nrorgOco,$nrOcorrencia,$nrVitima);
            
            foreach($partesAtingidas as $parte) {
                    
                $parte->delete();  
                                       
            }
            $vitima->delete(); //deleta vitima
            
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->flush();
            $db->commit();
            \Windows\WinSst00020000\TabSst00020000001\Facade::processAfterDelete();
            tk_reload_data_with_filter('tab_sst00020_000_001');
            tk_message($message, 'success');
        } catch (\Exception $e) {
            $message = tk_get_message_by_name('msg_ExclusaoImpossibilitada');
            tk_message($message, 'warning');
            $db->rollback();
        }      
            
        
    }
    
    public static function atualizaQtdVitimas($nrorgOco,$nrOcorrencia,$qtVitimas) {
            $db = \Setforms2\Runtime\Connection::getInstance();
            $db->getConn()->beginTransaction();
            
            try {
                $ocorrencia = \Folha\Entities\SstOcorrencia::findOneByNrorgAndNrocorrencia($nrorgOco,$nrOcorrencia);
                $ocorrencia->setQtvitimasocorre($qtVitimas);
                $ocorrencia->persist();
                
                $connection = \Setforms2\Shared\Registry::getEntityManager();
                $connection->flush();
                $db->commit();
            }            
            catch (\Exception $e) {
                throw $e;
                $db->rollback();
            }
    }
    
    public static function buscaNomeResponsavel($nrAcao,$nrOrg) {
        $acao = Acao::findOneByNrorgAndNracao($nrOrg, $nrAcao);
        if(is_object($acao)) {
            $nrResp = $acao->getCdoperrespac();
        }
        
        $operador = \Geral\Entities\Operador::findOneByCdoperador($nrResp);
        if(is_object($operador)) {
            return $operador->getNmoperador();
        }
        else {
            return '';
        }
        
        
    }
    
}

?>
